//HilfslinienUmwandeln_401d.js
// 19.01.09 / Hans Haesler, Chtelard 52, CH-1018 Lausanne
//Dieses Script wandelt Seiten-Hilfslinien in Druckbogen-Hilfslinien um (und umgekehrt)

// vorbeugenderweise das Anzeigen von Dialogen aktivieren
app.scriptPreferences.userInteractionLevel = UserInteractionLevels.interactWithAll;

if (app.documents.length == 0) {
	alert ("Es ist kein Dokument offen.", "Achtung");
	exit();
}

// aktuelles Dokument, aktueller Druckbogen, ausgewhlte Ebene
var curDoc = app.documents[0];
var curSpr = app.activeWindow.activeSpread;
var curLayer = app.activeWindow.activeLayer.index;

// die Auswahl testen
selItems = app.selection;
nItems = selItems.length;
var remSel = false;

// falls nichts ausgewhlt ist, vorsorglicherweise einen Frage stellen
if (nItems == 0) {
	var userDec = confirm ("Die Hilfslinien des aktuellen Druckbogens umwandeln?");
	if (userDec == false) {
		// nach dem Klick auf "No" die Ausfhrung abbrechen
		exit();
	}
	else {
		// nach dem Klick auf "Yes" alle Hilfslinien auswhlen
		curSpr.guides.everyItem().select();
		selItems = app.selection;
		nItems = selItems.length;
		remSel = true;
	}
}

// Variablen deklarieren
var curCol;
var curItem;
var curProps;
var ftPage;
var isDone;
var lock;
var newGuide;
var orient;
var posList = new Array ();

if (nItems > 0) {
	// eine Wiederholungsschleife durch die Auswahl
	for (var i=0; i<nItems; i++) {
		curItem = selItems[i];
		// den Typen des aktuellen Objekts prfen
		if (curItem.constructor.name == "Guide") {
			// die Attribute speichern
			curProps = curItem.properties;
			ftPage = curProps.fitToPage;
			orient = curProps.orientation;
			// Druckbogen oder Seite umkehren
			if (ftPage) {
				// falls es eine horizontale Seiten-Hilfslinie war
				if (orient == 1752134266) {
					curPos = curProps.location;
					isDone = false;
					// prfen, ob die aktuelle Position schon in der Liste vorkommt
					for (var k=0; k<posList.length; k++) {
						if (curPos == posList[k]) {
							isDone = true;
							break;
						}
					}
					try {
						// wenn schon eine Hilfslinie an dieser Position existiert, die aktuelle lschen
						if (isDone) {
							curItem.remove();
						}
						else {
							// sonst in eine Druckbogen-Hilfslinie umwandeln
							curItem.properties = {fitToPage:false};
							// die Position an die Liste anfgen
							posList.push(curPos);
						}
					}
					catch (e) {
					}
				}
				else {
					// sonst in eine Druckbogen-Hilfslinie umwandeln
					curItem.properties = {fitToPage:false};
				}
			}
			else {
				try {
					curItem.properties = {fitToPage:true};
					// falls es eine horizontale Druckbogen-Hilfslinie war, 
					// auf den danebenstehenden Seiten eine Seiten-Hilfslinie erzeugen
					if (orient == 1752134266) {
						curCol = curProps.guideColor;
						curPos = curProps.location;
						curThr = curProps.viewThreshold;
						lock = curProps.locked;
						doLock = false;
						// wenn nichts ausgewhlt war, die Ebene der aktuellen Hilfslinie aktivieren und, falls notwendig, entsperren
						if (remSel) {
							actLayer = curItem.itemLayer.name;
							app.activeWindow.activeLayer = curDoc.layers.item(actLayer);
							if (curDoc.layers.item(actLayer).locked == true) {
								curDoc.layers.item(actLayer).locked = false;
								doLock = true;
							}
						}
						// eine Schleife durch die Seiten und eine Seiten-Hilfslinie erzeugen
						for (var k=1; k<curSpr.pages.length; k++) {
							newGuide = curSpr.pages[k].guides.add(undefined, {orientation:HorizontalOrVertical.horizontal, location:curPos});
							newGuide.properties = {fitToPage:true, guideColor:curCol, viewThreshold:curThr, locked:lock};
						}
						// die Ebene wieder sperren, falls sie gesperrt war
						if (doLock) {
							curDoc.layers.item(actLayer).locked = true;
						}
					}
				}
				catch (e) {
				}
			}
		}
	}
}

// die Auswahl aufheben, wenn zu Beginn nichts ausgewhlt war
if (remSel) {
	app.selection = null;
}

// die ursprnglich ausgewhlte Ebene auswhlen
app.activeWindow.activeLayer = curDoc.layers[curLayer];
